/*
 * $Id: buffer.h,v 1.3 2003/03/04 11:41:20 tsavola Exp $
 * Dynamic buffer handling.
 * Timo Savola <timo.savola@movial.fi>
 */

#ifndef BUFFER_H
#define BUFFER_H

/** Normal buffer size. */
#define BUFFER_SIZE 8192

/** Dynamic buffer of arbitrary data. */
typedef struct {
	int start;
	int end;
	int eof;
	int mem_size;
	char *mem;
} buffer_t;

/** Is buffer empty and doesn't have EOF? */
#define buf_is_empty(buf) ((buf)->end == 0 && (buf)->eof == 0)

/** This closes the file when all data from the buffer is written out. */
#define buf_set_eof(buf)  ((buf)->eof = 1)

extern int buf_init(buffer_t *buf);
extern void buf_free(buffer_t *buf);
extern int buf_read_in(buffer_t *buf, int fd, int len);
extern int buf_write_out(buffer_t *buf, int *fd);

#endif
